Index: /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/PriorityRulesVector/PRVEncoding.cs
===================================================================
--- /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/PriorityRulesVector/PRVEncoding.cs	(revision 6177)
+++ /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/PriorityRulesVector/PRVEncoding.cs	(revision 6177)
@@ -0,0 +1,87 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Core;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Common;
+using HeuristicLab.Encodings.PermutationEncoding;
+using HeuristicLab.Data;
+using HeuristicLab.Problems.Scheduling.Interfaces;
+using HeuristicLab.Encodings.IntegerVectorEncoding;
+using HeuristicLab.Problems.Scheduling.Encodings.PriorityRulesVector.Crossovers;
+using HeuristicLab.Problems.Scheduling.Encodings.PriorityRulesVector.Manipulators;
+
+namespace HeuristicLab.Problems.Scheduling.Encodings.PriorityRulesVector {
+  [Item("Priority Rules Vector Encoding", "Represents a solution for a standard JobShop Scheduling Problem.")]
+  [StorableClass]
+  public class PRVEncoding : IntegerVector, IJSSPEncoding{
+    [StorableConstructor]
+    protected PRVEncoding(bool deserializing) : base(deserializing) { }
+    protected PRVEncoding(PRVEncoding original, Cloner cloner)
+      : base(original, cloner) {
+        this.nrOfRules = (IntValue)cloner.Clone(original.NrOfRules);
+    }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new PRVEncoding(this, cloner);
+    }
+
+    [Storable]
+    private IntValue nrOfRules;
+    public IntValue NrOfRules { 
+      get {
+        return nrOfRules;
+      } 
+    }
+
+
+    public PRVEncoding(IntValue nrOfRules)
+      : base() {
+        this.nrOfRules = (IntValue)nrOfRules.Clone();
+    }
+
+    public PRVEncoding (IntegerVector iv, IntValue nrOfRules) : base (iv.Length) {
+      this.nrOfRules = (IntValue)nrOfRules.Clone();
+      foreach (int i in iv) {
+        this[i] = iv[i];
+      }
+    }
+
+    public PRVEncoding(int length, IRandom random, int min, int max, IntValue nrOfRules) : base(length, random, min, max) {
+      this.nrOfRules = (IntValue)nrOfRules.Clone();
+    }
+
+    public override string ToString() {
+      StringBuilder sb = new StringBuilder();
+      sb.Append("[ ");
+
+      foreach (int i in this) {
+        sb.Append(i.ToString() + " ");
+      }
+
+      sb.Append("]");
+      return sb.ToString();
+    }
+  }
+}
Index: /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/PriorityRulesVector/PRVRandomCreator.cs
===================================================================
--- /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/PriorityRulesVector/PRVRandomCreator.cs	(revision 6177)
+++ /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/PriorityRulesVector/PRVRandomCreator.cs	(revision 6177)
@@ -0,0 +1,76 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Core;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Common;
+using HeuristicLab.Problems.Scheduling.Encodings.JobSequenceMatrix;
+using HeuristicLab.Optimization;
+using HeuristicLab.Parameters;
+using HeuristicLab.Data;
+using HeuristicLab.Encodings.PermutationEncoding;
+using HeuristicLab.Encodings.IntegerVectorEncoding;
+
+
+namespace HeuristicLab.Problems.Scheduling.Encodings.PriorityRulesVector {
+  [Item("Priority Rules Random Creator", "Creator class used to create PRV solutions for standard JobShop scheduling problems.")]
+  [StorableClass]
+  public class PRVRandomCreator : JSSPCreator<PRVEncoding>, IStochasticOperator {
+    [StorableConstructor]
+    protected PRVRandomCreator(bool deserializing) : base(deserializing) { }
+    protected PRVRandomCreator(PRVRandomCreator original, Cloner cloner)
+      : base(original, cloner) {
+        this.NrOfRules = cloner.Clone(original.NrOfRules);
+    }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new PRVRandomCreator(this, cloner);
+    }
+
+    public ILookupParameter<IRandom> RandomParameter {
+      get { return (LookupParameter<IRandom>)Parameters["Random"]; }
+    }
+
+    public IRandom Random {
+      get { return RandomParameter.ActualValue; }
+    }
+
+    [Storable]
+    public IntValue NrOfRules { get; set; }
+
+    public PRVRandomCreator()
+      : base() {
+      NrOfRules = new IntValue(10);
+      Parameters.Add(new LookupParameter<IRandom>("Random", "The pseudo random number generator."));
+    }
+
+
+    protected override PRVEncoding CreateSolution() {
+      IntValue nrOfJobs = new IntValue (Jobs.Count);
+      IntValue nrOfResources = new IntValue (Jobs[0].Tasks.Count);
+      PRVEncoding solution = new PRVEncoding(nrOfJobs.Value * nrOfResources.Value, Random, 0, NrOfRules.Value, NrOfRules);
+      return solution;
+    }
+  }
+}
Index: /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Evaluators/JSSPEvaluator.cs
===================================================================
--- /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Evaluators/JSSPEvaluator.cs	(revision 6177)
+++ /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Evaluators/JSSPEvaluator.cs	(revision 6177)
@@ -0,0 +1,75 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+
+
+using HeuristicLab.Core;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Optimization;
+using HeuristicLab.Data;
+using HeuristicLab.Common;
+using HeuristicLab.Parameters;
+using System;
+using HeuristicLab.Problems.Scheduling.Encodings.JobSequenceMatrix;
+using HeuristicLab.Problems.Scheduling.Encodings;
+using HeuristicLab.Operators;
+
+
+namespace HeuristicLab.Problems.Scheduling.Evaluators {
+  [Item("JSSP Evaluator", "Represents a evaluator class for standard job shop scheduling problems.")]
+  [StorableClass]
+  public abstract class JSSPEvaluator : JSSPOperator, ISingleObjectiveEvaluator {
+    [StorableConstructor]
+    protected JSSPEvaluator(bool deserializing) : base(deserializing) { }
+    protected JSSPEvaluator(JSSPEvaluator original, Cloner cloner)
+      : base(original, cloner) {
+    }
+
+    public ILookupParameter<IRandom> RandomParameter {
+      get { return (LookupParameter<IRandom>)Parameters["Random"]; }
+    }
+    public ILookupParameter<DoubleValue> QualityParameter {
+      get { 
+        if (Parameters.ContainsKey("Quality"))
+          return (ILookupParameter<DoubleValue>)Parameters["Quality"];
+        else
+          return null;
+      }
+    }
+    public ILookupParameter<Schedule> DecodedSchedulingSolutionParameter {
+      get { return (ILookupParameter<Schedule>)Parameters["DecodedSchedulingSolution"]; }
+    }
+
+    public JSSPEvaluator () : base () {
+      Parameters.Add(new LookupParameter<DoubleValue>("Quality", "The quality value aka fitness value of the solution."));
+      Parameters.Add(new LookupParameter<Schedule>("DecodedSchedulingSolution", "The decoded scheduling solution represented as generalized schedule."));
+      Parameters.Add(new LookupParameter<IRandom>("Random", "The pseudo random number generator."));
+    }
+
+    protected abstract DoubleValue evaluate(Schedule schedule);
+    
+    public override IOperation Apply() {
+      Schedule decodedSchedulingSolution = DecodedSchedulingSolutionParameter.ActualValue;
+      QualityParameter.ActualValue = evaluate(decodedSchedulingSolution);
+      return base.Apply();
+    }
+  }
+}
Index: /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Evaluators/MakespanEvaluator.cs
===================================================================
--- /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Evaluators/MakespanEvaluator.cs	(revision 6176)
+++ /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Evaluators/MakespanEvaluator.cs	(revision 6177)
@@ -34,5 +34,5 @@
   [Item("Makespan Evaluator", "Represents an evaluator using the maximum makespan of a schedule.")]
   [StorableClass]
-  public class MakespanEvaluator : JSSPEvaluator, IStochasticOperator {
+  public class MakespanEvaluator : JSSPEvaluator {
     [StorableConstructor]
     protected MakespanEvaluator(bool deserializing) : base(deserializing) { }
@@ -44,8 +44,5 @@
     }
 
-    
-
     public MakespanEvaluator () : base () { }
-
 
     protected override DoubleValue evaluate(Schedule schedule) {
Index: /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Evaluators/SchedulingEvaluator.cs
===================================================================
--- /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Evaluators/SchedulingEvaluator.cs	(revision 6177)
+++ /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Evaluators/SchedulingEvaluator.cs	(revision 6177)
@@ -0,0 +1,76 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Operators;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Core;
+using HeuristicLab.Common;
+using HeuristicLab.Problems.Scheduling.Encodings.JobSequenceMatrix;
+using HeuristicLab.Optimization;
+using HeuristicLab.Data;
+using HeuristicLab.Parameters;
+using HeuristicLab.Problems.Scheduling.Encodings.PriorityRulesVector;
+using HeuristicLab.Problems.Scheduling.Interfaces;
+using HeuristicLab.Problems.Scheduling.Encodings;
+
+namespace HeuristicLab.Problems.Scheduling.Evaluators {
+  [Item("Scheduling Evaluator", "Represents a general evaluator class for scheduling problems.")]
+  [StorableClass]
+  public class SchedulingEvaluator : AlgorithmOperator, ISchedulingEvaluator {
+    [StorableConstructor]
+    protected SchedulingEvaluator(bool deserializing) : base(deserializing) { }
+    protected SchedulingEvaluator(SchedulingEvaluator original, Cloner cloner)
+      : base(original, cloner) {
+    }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new SchedulingEvaluator(this, cloner);
+    }
+
+    public ILookupParameter<DoubleValue> QualityParameter {
+      get {
+        if (Parameters.ContainsKey("Quality"))
+          return (ILookupParameter<DoubleValue>)Parameters["Quality"];
+        else
+          return null;
+      }
+    }
+
+    public void InitializeOperatorGraph<T>(JSSPDecoder<T> decoder, JSSPEvaluator evaluator) where T: Item, IJSSPEncoding{
+      OperatorGraph.InitialOperator = decoder;
+      decoder.Successor = evaluator;
+    }
+
+    public SchedulingEvaluator()
+      : base() {
+        Parameters.Add(new LookupParameter<DoubleValue>("Quality", "The quality value aka fitness value of the solution."));
+        InitializeOperatorGraph<JSMEncoding>(new JSMDecoder(), new MakespanEvaluator());
+    }
+
+    public override IOperation Apply() {
+      return base.Apply();
+    }
+
+  }
+}
Index: /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/HeuristicLab.Problems.Scheduling-3.3.csproj
===================================================================
--- /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/HeuristicLab.Problems.Scheduling-3.3.csproj	(revision 6176)
+++ /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/HeuristicLab.Problems.Scheduling-3.3.csproj	(revision 6177)
@@ -49,28 +49,49 @@
   <ItemGroup>
     <Compile Include="Analyzers\BestSchedulingSolutionAnalyzer.cs" />
+    <Compile Include="Encodings\JobSequenceMatrix\JSMDecodingErrorPolicyTypes.cs" />
+    <Compile Include="Encodings\JobSequenceMatrix\Crossovers\JSMJOXCrossover.cs" />
     <Compile Include="Encodings\JobSequenceMatrix\Crossovers\JSMCrossover.cs" />
+    <Compile Include="Encodings\JobSequenceMatrix\Crossovers\JSMOrderCrossover.cs" />
     <Compile Include="Encodings\JobSequenceMatrix\Crossovers\JSMSXXCrossover.cs" />
     <Compile Include="Encodings\JobSequenceMatrix\JSMDecoder.cs" />
+    <Compile Include="Encodings\JobSequenceMatrix\JSMForcingStrategyTypes.cs" />
     <Compile Include="Encodings\JobSequenceMatrix\JSMRandomCreator.cs" />
     <Compile Include="Encodings\JobSequenceMatrix\JSMEncoding.cs" />
+    <Compile Include="Encodings\JobSequenceMatrix\Manipulators\JSMShiftChangeManipulator.cs" />
     <Compile Include="Encodings\JobSequenceMatrix\Manipulators\JSMManipulator.cs" />
-    <Compile Include="Encodings\JobSequenceMatrix\Manipulators\JSMSwapManipulator.cs" />
+    <Compile Include="Encodings\JobSequenceMatrix\Manipulators\JSMInsertionManipulator.cs" />
     <Compile Include="Encodings\JSSPCrossover.cs" />
-    <Compile Include="Encodings\JSSPEncoding.cs" />
+    <Compile Include="Encodings\JSSPDecoder.cs" />
+    <Compile Include="Encodings\JSSPEncodingTypes.cs" />
+    <Compile Include="Encodings\PriorityRulesVector\Crossovers\PRVSinglePointCrossover.cs" />
+    <Compile Include="Encodings\PriorityRulesVector\Crossovers\PRVDiscreteCrossover.cs" />
+    <Compile Include="Encodings\PriorityRulesVector\Manipulators\PRVUniformOnePositionManipulator.cs" />
+    <Compile Include="Encodings\PriorityRulesVector\PRVEncoding.cs" />
+    <Compile Include="Interfaces\IJSSPDecoder.cs" />
+    <Compile Include="Interfaces\IJSSPOperator.cs" />
+    <Compile Include="Interfaces\IPRVOperator.cs" />
+    <Compile Include="Interfaces\IJSSPEncoding.cs" />
     <Compile Include="Encodings\JSSPCreator.cs" />
     <Compile Include="Encodings\JSSPManipulator.cs" />
+    <Compile Include="Encodings\PriorityRulesVector\Crossovers\PRVCrossover.cs" />
+    <Compile Include="Encodings\PriorityRulesVector\PRVDecoder.cs" />
+    <Compile Include="Encodings\PriorityRulesVector\PRVRandomCreator.cs" />
+    <Compile Include="Encodings\PriorityRulesVector\Manipulators\PRVManipulator.cs" />
     <Compile Include="Evaluators\MakespanEvaluator.cs" />
+    <Compile Include="IndexedTaskList.cs" />
     <Compile Include="Interfaces\IJSMOperator.cs" />
     <Compile Include="Interfaces\IJSSPCrossover.cs" />
     <Compile Include="Interfaces\IJSSPManipulator.cs" />
+    <Compile Include="Interfaces\ISchedulingCreator.cs" />
+    <Compile Include="Interfaces\ISchedulingEvaluator.cs" />
     <Compile Include="Resource.cs" />
-    <Compile Include="JSSPEvaluator.cs" />
-    <Compile Include="SchedulingCreator.cs" />
+    <Compile Include="Evaluators\JSSPEvaluator.cs" />
+    <Compile Include="Interfaces\IJSSPCreator.cs" />
     <Compile Include="JSSPJob.cs" />
     <Compile Include="JobShopSchedulingProblem.cs" />
     <Compile Include="JSSPTask.cs" />
-    <Compile Include="SchedulingOperator.cs" />
+    <Compile Include="Encodings\JSSPOperator.cs" />
+    <Compile Include="Evaluators\SchedulingEvaluator.cs" />
     <Compile Include="SchedulingProblem.cs" />
-    <Compile Include="Task.cs" />
     <Compile Include="Plugin.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
@@ -103,4 +124,8 @@
       <Name>HeuristicLab.Data-3.3</Name>
     </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.Encodings.IntegerVectorEncoding\3.3\HeuristicLab.Encodings.IntegerVectorEncoding-3.3.csproj">
+      <Project>{DDFB14DD-2A85-493C-A52D-E69729BBAEB0}</Project>
+      <Name>HeuristicLab.Encodings.IntegerVectorEncoding-3.3</Name>
+    </ProjectReference>
     <ProjectReference Include="..\..\HeuristicLab.Encodings.PermutationEncoding\3.3\HeuristicLab.Encodings.PermutationEncoding-3.3.csproj">
       <Project>{DBECB8B0-B166-4133-BAF1-ED67C3FD7FCA}</Project>
@@ -128,7 +153,5 @@
     </ProjectReference>
   </ItemGroup>
-  <ItemGroup>
-    <Folder Include="Encodings\PriorityRulesVector\" />
-  </ItemGroup>
+  <ItemGroup />
   <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
   <PropertyGroup>
Index: /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/IndexedTaskList.cs
===================================================================
--- /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/IndexedTaskList.cs	(revision 6177)
+++ /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/IndexedTaskList.cs	(revision 6177)
@@ -0,0 +1,83 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Core;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Common;
+using HeuristicLab.Parameters;
+using HeuristicLab.Data;
+
+namespace HeuristicLab.Problems.Scheduling {
+  [Item("Indexed Tasklist", "Represents a list of tasks.")]
+  [StorableClass]
+  public class IndexedTaskList : ParameterizedNamedItem {
+    [StorableConstructor]
+    protected IndexedTaskList(bool deserializing) : base(deserializing) { }
+    protected IndexedTaskList(IndexedTaskList original, Cloner cloner)
+      : base(original, cloner) {
+      this.Index = cloner.Clone(original.Index);
+      this.Tasks = cloner.Clone(original.Tasks);
+    }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new IndexedTaskList(this, cloner);
+    }
+
+    #region Parameter Properties
+    public ValueParameter<IntValue> IndexParameter {
+      get { return (ValueParameter<IntValue>)Parameters["Index"]; }
+    }
+    public ValueParameter<ItemList<JSSPTask>> TasksParameter {
+      get { return (ValueParameter<ItemList<JSSPTask>>)Parameters["Tasks"]; }
+    }
+    #endregion
+
+    #region Properties
+    public IntValue Index {
+      get { return IndexParameter.Value; }
+      set { IndexParameter.Value = value; }
+    }
+    public ItemList<JSSPTask> Tasks {
+      get { return TasksParameter.Value; }
+      set { TasksParameter.Value = value; }
+    }
+    #endregion
+
+    public IndexedTaskList (IntValue index) : base (){
+      Parameters.Add(new ValueParameter<IntValue>("Index", "The index of the resource in the associated Scheduling Problem.", new IntValue()));
+      Parameters.Add(new ValueParameter<ItemList<JSSPTask>>("Tasks", "Taskdata defining duration, start-time and resource assignment of the tasks.", new ItemList<JSSPTask>()));
+      Index = index;
+    }
+
+    public override string ToString() {
+      StringBuilder sb = new StringBuilder();
+      sb.Append("TaskList#" + Index + " [ ");
+      foreach (JSSPTask t in Tasks) {
+        sb.Append(t.ToString() + " ");
+      }
+      sb.Append("]");
+      return sb.ToString();
+    }
+  }
+}
Index: /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Interfaces/IJSSPCreator.cs
===================================================================
--- /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Interfaces/IJSSPCreator.cs	(revision 6177)
+++ /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Interfaces/IJSSPCreator.cs	(revision 6177)
@@ -0,0 +1,35 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Optimization;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Core;
+using HeuristicLab.Common;
+using HeuristicLab.Parameters;
+
+namespace HeuristicLab.Problems.Scheduling.Interfaces {
+  public interface IJSSPCreator : IJSSPOperator, ISchedulingCreator {
+  }
+}
Index: /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Interfaces/IJSSPCrossover.cs
===================================================================
--- /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Interfaces/IJSSPCrossover.cs	(revision 6176)
+++ /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Interfaces/IJSSPCrossover.cs	(revision 6177)
@@ -8,7 +8,7 @@
 
 namespace HeuristicLab.Problems.Scheduling.Interfaces {
-  interface IJSSPCrossover : ICrossover{
-    ILookupParameter<ItemArray<JSSPEncoding>> ParentsParameter { get; }
-    ILookupParameter<JSSPEncoding> ChildParameter { get; }
+  public interface IJSSPCrossover : ICrossover{
+    ILookupParameter<ItemArray<IJSSPEncoding>> ParentsParameter { get; }
+    ILookupParameter<IJSSPEncoding> ChildParameter { get; }
   }
 }
Index: /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Interfaces/IJSSPDecoder.cs
===================================================================
--- /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Interfaces/IJSSPDecoder.cs	(revision 6177)
+++ /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Interfaces/IJSSPDecoder.cs	(revision 6177)
@@ -0,0 +1,37 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Core;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Common;
+using HeuristicLab.Encodings.PermutationEncoding;
+using HeuristicLab.Data;
+using HeuristicLab.Parameters;
+
+namespace HeuristicLab.Problems.Scheduling.Interfaces {
+  public interface IJSSPDecoder : IOperator {
+
+  }
+}
Index: /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Interfaces/IJSSPEncoding.cs
===================================================================
--- /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Interfaces/IJSSPEncoding.cs	(revision 6177)
+++ /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Interfaces/IJSSPEncoding.cs	(revision 6177)
@@ -0,0 +1,37 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Core;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Common;
+using HeuristicLab.Encodings.PermutationEncoding;
+using HeuristicLab.Data;
+using HeuristicLab.Parameters;
+using HeuristicLab.Problems.Scheduling.Encodings;
+
+namespace HeuristicLab.Problems.Scheduling.Interfaces {
+  public interface IJSSPEncoding : IItem {
+  }
+}
Index: /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Interfaces/IJSSPManipulator.cs
===================================================================
--- /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Interfaces/IJSSPManipulator.cs	(revision 6176)
+++ /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Interfaces/IJSSPManipulator.cs	(revision 6177)
@@ -26,5 +26,5 @@
 namespace HeuristicLab.Problems.Scheduling.Interfaces {
   public interface IJSSPManipulator : IManipulator {
-    ILookupParameter<JSSPEncoding> SchedulingSolutionParameter { get; }
+    ILookupParameter<IJSSPEncoding> SchedulingSolutionParameter { get; }
   }
 }
Index: /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Interfaces/IJSSPOperator.cs
===================================================================
--- /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Interfaces/IJSSPOperator.cs	(revision 6177)
+++ /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Interfaces/IJSSPOperator.cs	(revision 6177)
@@ -0,0 +1,11 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Core;
+
+namespace HeuristicLab.Problems.Scheduling.Interfaces {
+  public interface IJSSPOperator : IOperator {
+    ILookupParameter<ItemList<JSSPJob>> JobsParameter { get; }
+  }
+}
Index: /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Interfaces/IPRVOperator.cs
===================================================================
--- /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Interfaces/IPRVOperator.cs	(revision 6177)
+++ /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Interfaces/IPRVOperator.cs	(revision 6177)
@@ -0,0 +1,10 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Core;
+
+namespace HeuristicLab.Problems.Scheduling.Interfaces {
+  interface IPRVOperator : IOperator {
+  }
+}
Index: /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Interfaces/ISchedulingCreator.cs
===================================================================
--- /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Interfaces/ISchedulingCreator.cs	(revision 6177)
+++ /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Interfaces/ISchedulingCreator.cs	(revision 6177)
@@ -0,0 +1,10 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Optimization;
+
+namespace HeuristicLab.Problems.Scheduling.Interfaces {
+  public interface ISchedulingCreator : ISolutionCreator {
+  }
+}
Index: /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Interfaces/ISchedulingEvaluator.cs
===================================================================
--- /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Interfaces/ISchedulingEvaluator.cs	(revision 6177)
+++ /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Interfaces/ISchedulingEvaluator.cs	(revision 6177)
@@ -0,0 +1,10 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Optimization;
+
+namespace HeuristicLab.Problems.Scheduling.Interfaces {
+  public interface ISchedulingEvaluator : ISingleObjectiveEvaluator {
+  }
+}
